if [ -z "$1" ]
  then
  QUARTUS_NAME=soc_system
else
  QUARTUS_NAME=$1
fi

if [ -z "$2" ]
  then 
  QSYS_NAME=$QUARTUS_NAME
else
  QSYS_NAME=$2
fi

fail () {
msg=$*
echo "Error: $msg"
exit -1
}

echo "Quartus name: $QUARTUS_NAME";
echo "Qsys name   : $QSYS_NAME";

# generate altsource_probe for hps_reset
#qsys-generate --synthesis=VERILOG ip/altsource_probe/hps_resets.qsys || fail "HPS RESETS Qsys system generation failed"

tclsh create_ghrd_top.tcl || fail "System top creation failed"
qsys-script --script=create_ghrd_qsys.tcl --cmd="set qsys_name $QSYS_NAME" || fail "$QSYS_NAME Qsys creation failed"
qsys-generate --synthesis=VERILOG $QSYS_NAME.qsys || fail "Qsys system generation failed"

quartus_sh --script=create_ghrd_quartus.tcl projectname $QUARTUS_NAME qsysname $QSYS_NAME || fail "$QUARTUS_NAME Quartus project creation failed"
quartus_map $QUARTUS_NAME.qpf || fail "Quartus map failed"
quartus_sh -r -t "$QSYS_NAME/synthesis/submodules/hps_sdram_p0_pin_assignments.tcl" $QUARTUS_NAME.qpf || "Quartus tcl execution failed"
quartus_sh --flow compile $QUARTUS_NAME.qpf || fail "Quartus full compilation failed"
